%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Function description:
%I: Input image in YCbCr color space
%factor: Between 0 and 1 (determining degree of shift to max. sat. point)
%shift: amount of shift towards the (Cb,Cr)
%threshold: Applied beyond this value
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
function out=sat_CbCr(I,factor,shift,Threshold)


[height width depth]=size(I);
%Y=I(:,:,1); 
Cb=double(I(:,:,2))-128; Cr=double(I(:,:,3))-128;
out=I;
for i=1:height
    for j=1:width
       if(abs(Cb(i,j))>abs(Cr(i,j)))
           if((abs(Cb(i,j))>Threshold))% && (abs(Cb(i,j)+sign(Cb(i,j))*shift)<100))
           m=Cr(i,j)/Cb(i,j);
           Cb(i,j)=Cb(i,j)+sign(Cb(i,j))*shift;
           Cr(i,j)=factor*m*Cb(i,j);
           end
       else
           if((abs(Cr(i,j))>Threshold))%&& (abs(Cr(i,j)+sign(Cr(i,j))*shift)<100))
           m=Cb(i,j)/Cr(i,j);
           Cr(i,j)=Cr(i,j)+sign(Cr(i,j))*shift;
           Cb(i,j)=factor*m*Cr(i,j);
           end
       end
    end
end
  out(:,:,2)=Cb+128;
  out(:,:,3)=Cr+128;
  return
  