%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Description:
% The program demonstrates image resizing with rational factors.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sprintf('Arbitrary Rational Resizing main: 8/6/2010')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear
tic

sprintf('Image Resizing be L x M')


clear
tic

 imagedir='../test_images/';
image = 'watch.orig';

L=3;
 M=2;
 
 
 N=8;
 

 P=2;
 Q=3;
 L=3;
 M=2;
 

 
 fx=P/L;
 fy=Q/M;
 

 
 
 
 
 

I 		= imread( [sprintf(imagedir) sprintf(image) '.jpg'],'jpg');

sprintf('Image loaded')

 
 [height width]=size(I);
 

 
   figure(1); imshow(I); title(sprintf(image));
   
   
    dct_I=blkproc(I,[N,N],@dct2);
    resize_dct_I=blkproc(dct_I,[L*N,M*N],@Arbitrary_resize,L,M,P,Q);
    
    I_resize=blkproc(resize_dct_I,[N,N],@idct2);
    
     [h_r w_r]=size(I_resize);
     

   h_d=floor(height*fx);
   w_d=floor(width*fy);
   if(h_r<h_d)
       h_d=h_r;
   end
   if(w_r<w_d)
       w_d=w_r;
   end

figure(2); imshow(uint8(I_resize(1:h_d,1:w_d))); title('Resized image');

 I_resize1=uint8(I_resize(1:h_d,1:w_d));
 
%Reverse Operation


I_d=I;
h_d=height;
w_d=width;

fx=L/P;
fy=M/Q;

    dct_I=blkproc(I_d,[N,N],@dct2);
    resize_dct_I=blkproc(dct_I,[P*N,Q*N],@Arbitrary_resize,P,Q,L,M);
    
    I_resize=blkproc(resize_dct_I,[N,N],@idct2);
    
     [h_r w_r]=size(I_resize);
     
     
     
   h_u=floor(h_d*fx);
   w_u=floor(w_d*fy);
   if(h_r<h_u)
       h_u=h_r;
   end
   if(w_r<w_u)
       w_u=w_r;
   end
     
figure(3); imshow(uint8(I_resize(1:h_u,1:w_u))); title('Resized image');

  
toc