%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description:
% Implementation of the LMDS algorithm.
% X: L x M adjacent DCT blocks.
% Y: A single DCT block.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Y=LM_downsize(X,L,M)

[height width]=size(X);

 A1=block_composition_matrix(L,height/L);
 
 A2=block_composition_matrix(M,width/M);
 
 
 tY=A1*X*A2';
 
 Y=(1/(sqrt(L*M)))*tY(1:8,1:8);
 
 
  return
