%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description:
% Implementation of image doubling in the spatial domain.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function J=doubleImage(I)

[r c]=size(I);

 uJ=zeros(2*r,2*c);
 dI=double(I);

 for i=1:r
     for j=1:c
          uJ(2*i-1,2*j-1)=dI(i,j);
          uJ(2*i-1,2*j)=dI(i,j);
          uJ(2*i,2*j-1)=dI(i,j);
          uJ(2*i,2*j)=dI(i,j);
%           uJ(i,j)= (dI(2*i-1,2*j-1)+dI(2*i-1,2*j)+dI(2*i,2*j-1)+dI(2*i,2*j))/4;
      end
  end
  
  J=uint8(uJ);
  
  return
