%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function Description:
% Implementation of image halving in the spatial domain.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function J=halfImage(I)

[r c]=size(I);

 dJ=zeros(r/2,c/2);
 dI=double(I);

 for i=1:r/2
     for j=1:c/2
          dJ(i,j)= (dI(2*i-1,2*j-1)+dI(2*i-1,2*j)+dI(2*i,2*j-1)+dI(2*i,2*j))/4;
      end
  end
  
  J=uint8(dJ);
  
  return
         