%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Converts image from normalized XYZ color space  to CIE-XYZ.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
function out=NXYZ_XYZ(I)
%Assume input in XYZ space

nX= double(I(:,:,1));
nY = double(I(:,:,2));
nZ= double(I(:,:,3));


X=nX.*nZ;
Y=nY.*nZ;
Z=nZ-(X+Y);



out(:,:,1) = X;
out(:,:,2) =  Y;
out(:,:,3) =  Z;

 
  return