%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Converts pixels in  RGB color space to CIE-XYZ color space. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [X Y Z]=RGB2XYZ(R,G,B)



Tr1 = [0.31 0.20 0.49; 0.813 0.011 0.177; 0.01 0.99 0];


dR=double(R);
dG=double(G);
dB=double(B);

X 	= Tr1(1,1)*dG +	Tr1(1,2)*dB + Tr1(1,3)*dR; 
Y	= Tr1(2,1)*dG +	Tr1(2,2)*dB + Tr1(2,3)*dR;
Z	= Tr1(3,1)*dG +	Tr1(3,2)*dB + Tr1(3,3)*dR;

  return