%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Converts a pixel in  normalized CIE-XYZ color space to CIE-XYZ color space. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [nX nY nZ]=XYZ2NXYZ(X,Y,Z)
%Assume input in XYZ space



nZ=X+Y+Z;
if(nZ>.00001)
    nX=X/nZ;
    nY=Y/nZ;
else
    nX=1/3.0;
    nY=1/3.0;
end

  return