%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Converts image from XYZ to RGB color space.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
function out=XYZ_RGB(I)

Tr1 = [0.31 0.20 0.49; 0.813 0.011 0.177; 0.01 0.99 0];
Tr3 = inv(Tr1);
% Tr1 =       [ 0.299   0.587   0.114
%              -0.173  -0.339   0.511
%               0.511  -0.428  -0.083];
% Tr3 = inv(Tr1);

X= double(I(:,:,1));
Y = double(I(:,:,2));
Z= double(I(:,:,3));




G = Tr3(1,1)*X + Tr3(1,2)*Y + Tr3(1,3)*Z;
B = Tr3(2,1)*X + Tr3(2,2)*Y + Tr3(2,3)*Z;
R = Tr3(3,1)*X + Tr3(3,2)*Y + Tr3(3,3)*Z;  


 out(:,:,1) = R;
out(:,:,2) =  G;
out(:,:,3) =  B;

  out=uint8(out);
 
  return