%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It computes arctan of l/m.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function tht=arctan(l,m)
% returns between 0 and 2*PI by computing tan inv. of (m/l)
           M_PI=pi;
           if (l==0) 
              if(m>0) 
                 tht=M_PI/2;
              else
                 tht= 3*M_PI/2;
              end
           else
               tht=atan(abs(m/l));
           end
           if (l<0)
              if (m>0) 
                 tht=M_PI-tht;
              else
                  tht=M_PI+tht;
              end
           else
              if (m<0)
                  tht=2*M_PI-tht;
              end
           end
              return
   

