%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It converts a vector X into the off-diagonal matrix such that elements
% are placed at (i,j)th location if j-i=1.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Y=convert_off_diagonal_matrix(X,l)

[length height]=size(X);

Y=zeros(length+abs(l),length+abs(l));

k=1;
for i=1:length+abs(l)
    for j=1:length+abs(l)
    if((i+l==j))
    Y(i,j)=X(k);
    k=k+1;
    end
    end
end
return