%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It computes PSNR values between two images.
% ref---> Reference  image.
% rec---> Reconstructed  image. 
% val---> PSNR value in DB.
% It works for  grey  images.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 function val=psnr(ref,rec)
  R=double(ref);
  R1=double(rec);
  [r c]=size(R);
  err=sum(sum((R-R1).*(R-R1)))/(r*c);
  sqrterr=sqrt(err);
  val=20*log10(255.0/sqrterr);
  return
