%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Implementation of MXW-YCbCr. CI should be in YCbCr space.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [mxY Cb Cr]=max_illuminant_YCbCr(CI)

[h w d]=size(CI);


mxY=0;

 for i=1:h
     for j=1:w
         if(CI(i,j,1)>mxY)
             mxY=CI(i,j,1);
             Cb=CI(i,j,2);
             Cr=CI(i,j,3);
         end
         
     end
 end
   
   return