%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It takes the DCT of YCbCr and shifts the chromaticity by shiftU and
% shiftV.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function dct_CI_CC=shift_chromaticity_JPEG(dct_CI_ycbcr,shiftU,shiftV)

[height width depth]=size(dct_CI_ycbcr);
 dct_CI_CC=dct_CI_ycbcr;
dct_CI_CC(1:8:height,1:8:width,2)=dct_CI_ycbcr(1:8:height,1:8:width,2)+8*shiftU;
dct_CI_CC(1:8:height,1:8:width,3)=dct_CI_ycbcr(1:8:height,1:8:width,3)+8*shiftV;
return