%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Function description:
%(xw,yw): Ref_white (xe1,ye1) & (xe2,ye2): An edge of the color gamut.
%(x1,y1): Input point in NXYZ  
%(px,py): intersection point between lines (xw,yw)--(x1,y1) and 
 % (xe1,ye1)--(xe2,ye2).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
function [px py]=find_xy(x1,y1,xw,yw,xe1,ye1,xe2,ye2)


        p=(ye2-ye1)/(xe2-xe1);
        if(abs(x1-xw)>0)
	     q=(y1-yw)/(x1-xw);
	     px=(yw-ye1+p*xe1-q*xw)/(p-q);
	     py=ye1+p*(px-xe1);
        else
         px=xw;
         py=ye1+p*(xw-xe1);
        end
    return