%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It provides Cosine to Sine conversion matrix for composing M adjacent 
% N-point DCT blocks inot an MN-point DST block.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function a = convert_CST(M,N)

  a=zeros(M*N,M*N);
  
  B_MN=dst_type2_basis(M*N);
  B_N=dct_type2_basis(N);
  B_mod=zeros(M*N,M*N);
  
  for u=0:M-1
      B_mod(u*N+1:u*N+N,u*N+1:u*N+N)=B_N;
  end
   a=B_MN*inv(B_mod);
return