%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It Computes transformation matrix for obtaining even down-sampled 
% sequence from its DCT.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function B = dct_dn2_bs_even(N)
%Even down-sampling
  B=zeros(N/2,N);
  
  for k=1:N
      for t=1:N/2
          B(t,k)=sqrt(2/N)*cos((pi*((t-1)+1/4)*(k-1))/(N/2));
        if(k==1)
            B(t,k)=(1/sqrt(2))*B(t,k);
        end
        end
  end
return