%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It provides an N-point type-I DCT transformation matrix. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function B = dct_type1_basis(N)

  B=zeros(N+1,N+1);
  
  for k=1:N+1
      for t=1:N+1 
          
        B(k,t)=(sqrt(2/N))*cos(((t-1)*(k-1)*pi)/N);
           if((t==1) | (t==(N+1)))
            B(k,t)=B(k,t)/2;
           end
        end
  end
  
return