%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It provides an N-point type-II DCT transformation matrix. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function B = dct_type2_basis(N)

  B=zeros(N,N);
  
  for k=1:N
      for t=1:N 
          
        B(k,t)=sqrt(2/N)*cos(((2*(t-1)+1)*(k-1)*pi)/(2*N));
        if(k==1)
            B(k,t)=(1/sqrt(2))*B(k,t);
        end        
        end
  end
  
return