%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. K. Viswanath, SIT, Karanataka
% and Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It computes transformation matrix for obtaining zero inserted
% odd upsampled DCT from a sequence.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function B = dct_up2_bs_odd(N)
%%% zeros in the odd samples
% 0 1 0 1 like this
  B=zeros(2*N,N);
  
 for k=1:2*N
      for t=1:N 
          B(k,t)=sqrt(1/N)*cos((pi*((t-1)+3/4)*(k-1))/N);
 
         if(k==1)
          B(k,t)=(1/sqrt(2))*B(k,t);
        end
%       B(k,t)=2*cos(((2*(t-1)+1)*(k-1)*pi)/(2*N));
        end
  end
return