%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It returns transformation matrix for N-point type-II DST.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
function B = dst_type2_basis(N)

  B=zeros(N,N);
  
  for k=1:N
      for t=1:N 
        B(k,t)=sqrt(2/N)*sin(((2*t-1)*k)*pi/(2*N));
        if(k==N)
            B(k,t)=(1/sqrt(2))*B(k,t);
        end
        end
  end
  
return