%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% CI in RGB space is converted to its DCT in YCbCr space.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [dct_CI_ycbcr maxDC]=get_DCT_JPEG(CI)  
 CI_ycbcr=RGB_YCbCr(CI);
 Y=CI_ycbcr(:,:,1);
 maxDC=double(max(max(Y)));

 Cb=CI_ycbcr(:,:,2);
 Cr=CI_ycbcr(:,:,3);
     
 dct_Y=blkproc(Y,[8,8],@dct2);
 dct_Cb=blkproc(Cb,[8 8],@dct2);
 dct_Cr=blkproc(Cr,[8 8],@dct2);
    
    
    
    
     dct_CI_ycbcr(:,:,1)=dct_Y;
     dct_CI_ycbcr(:,:,2)=dct_Cb;
     dct_CI_ycbcr(:,:,3)=dct_Cr;
     
     return