%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% CI in RGB space converted from its DCT as dct_CI_ycbcr in YCbCr space.
% CI is in double.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function CI=get_Image_from_DCT_JPEG(dct_CI_ycbcr) 

 
 Y=blkproc(dct_CI_ycbcr(:,:,1),[8,8],@idct2);
Cb=blkproc(dct_CI_ycbcr(:,:,2),[8,8],@idct2);
Cr=blkproc(dct_CI_ycbcr(:,:,3),[8,8],@idct2);

 CI_ycbcr(:,:,1)=Y;
 CI_ycbcr(:,:,2)=Cb;
 CI_ycbcr(:,:,3)=Cr;
 CI=YCbCr_RGB(CI_ycbcr);
     
     return