%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Converts image from  RGB to XYZ color space.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
function out=RGB_XYZ(I)

Tr1 = [0.31 0.20 0.49; 0.813 0.011 0.177; 0.01 0.99 0];
%Tr3 = inv(Tr1);


R = double(I(:,:,1));
G = double(I(:,:,2));
B = double(I(:,:,3));

X 	= Tr1(1,1)*G +	Tr1(1,2)*B + Tr1(1,3)*R; 
Y	= Tr1(2,1)*G +	Tr1(2,2)*B + Tr1(2,3)*R;
Z	= Tr1(3,1)*G +	Tr1(3,2)*B + Tr1(3,3)*R;


 out(:,:,1) = X;
out(:,:,2) = Y;
out(:,:,3) = Z;
 
  return