%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% Converts pixels in  CIE-XYZ color space to RGB color space. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [R G B]=XYZ2RGB(X,Y,Z)



Tr1 = [0.31 0.20 0.49; 0.813 0.011 0.177; 0.01 0.99 0];
Tr3 = inv(Tr1);

G = uint8(Tr3(1,1)*X + Tr3(1,2)*Y + Tr3(1,3)*Z);
B = uint8(Tr3(2,1)*X + Tr3(2,2)*Y + Tr3(2,3)*Z);
R = uint8(Tr3(3,1)*X + Tr3(3,2)*Y + Tr3(3,3)*Z);  


  return