%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% These codes are written by Prof. Jayanta Mukhopadhyay, IIT Kharagpur.
% The codes may be used freely for any academic and research 
% purpose with appropriate acknowledgement.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function description:
% It returns gaussian function values in  M * N array with mean at (xc,yc)
% and standard deviation as sigma.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function g=gaussian(M,N,xc,yc,sigma) 

 g=zeros(M,N);
 for x=1:M
     for y=1:N
         g(x,y)=exp(-((x-xc)*(x-xc)+(y-yc)*(y-yc))/(2*sigma*sigma))/(2*pi*sigma*sigma);
     end
 end
 return